VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} GoToSheetSelectorUserForm 
   Caption         =   "Go To Sheet"
   ClientHeight    =   4785
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   4410
   OleObjectBlob   =   "GoToSheetSelectorUserForm.frx":0000
   StartUpPosition =   2  'CenterScreen
End
Attribute VB_Name = "GoToSheetSelectorUserForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False






Option Explicit

Private Sub UserForm_Initialize()
  Dim Obj As Object
  With Me
    .StartUpPosition = 0
    .Left = Application.Left + (0.5 * Application.Width) - (0.5 * .Width)
    .Top = Application.Top + (0.5 * Application.Height) - (0.5 * .Height)
  End With
  TextBox1.Text = ""
  TextBox1.EnterKeyBehavior = True
  For Each Obj In Sheets
    If Obj.Visible = xlSheetVisible Then ListBox1.AddItem Obj.Name
  Next
  TextBox1.SetFocus
End Sub

Private Sub ListBox1_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
  With TextBox1
    If KeyCode = vbKeyLeft Then
      ListBox1.ListIndex = -1
      .SelStart = Len(.Text)
      .SetFocus
    ElseIf KeyCode = vbKeyReturn Then
      If ListBox1.ListCount > 0 Then
        Sheets(ListBox1.Text).Activate
        Unload Me
      End If
    End If
  End With
End Sub

Private Sub ListBox1_MouseUp(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Single, ByVal Y As Single)
  Sheets(ListBox1.List(ListBox1.ListIndex)).Activate
  Unload Me
End Sub

Private Sub TextBox1_Change()
  Dim X As Long
  ListBox1.Clear
  For X = 1 To Sheets.Count
    If InStr(1, Sheets(X).Name, TextBox1.Text, vbTextCompare) Then ListBox1.AddItem Sheets(X).Name
  Next
End Sub

Private Sub TextBox1_KeyDown(ByVal KeyCode As MSForms.ReturnInteger, ByVal Shift As Integer)
  With ListBox1
    If KeyCode = vbKeyReturn Then
      KeyCode = 0
      If .ListCount = 0 Then
        Exit Sub
      ElseIf .ListCount = 1 Then
        Sheets(.List(0)).Activate
        Unload Me
      Else
        .SetFocus
        .Selected(0) = True
        .ListIndex = 0
      End If
    ElseIf (KeyCode = vbKeyDown Or (KeyCode = vbKeyRight And TextBox1.SelStart = Len(TextBox1.Text))) And .ListCount > 0 Then
      .SetFocus
      .Selected(0) = True
      .ListIndex = 0
    End If
  End With
End Sub
